package application;

import javafx.scene.Scene;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.Label;
import javafx.scene.control.Slider;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.stage.Stage;
import model.Getrank;
import model.GetrankException;

public class GetrankDialog extends Stage
{
	private GridPane gridPane;
	private Label labelAlkoholisch;
	private CheckBox checkBoxAlkoholisch;
	private Label labelMl;
	private TextField textFieldMl;
	private Label labelPreis;
	private Slider sliderPreis;
	private Button buttonOk, buttonAbbruch;
	
	private Getrank getrank;
	
	public GetrankDialog()
	{
		initComponents();
		addComponents();
		addHandlers();
	}

	private void initComponents()
	{
		setTitle("Getränk ändern");
		gridPane = new GridPane();
		labelAlkoholisch = new Label("Alkoholisch:");
		checkBoxAlkoholisch = new CheckBox();
		labelMl = new Label("Ml:");
		textFieldMl = new TextField();
		labelPreis = new Label("Preis");
		sliderPreis = new Slider(0.5, 4, 2);
			sliderPreis.setMajorTickUnit(0.5);
			sliderPreis.setShowTickLabels(true);
		buttonOk = new Button("OK");
		buttonAbbruch = new Button("Abbruch");
	}

	private void addComponents()
	{
		gridPane.add(labelAlkoholisch, 0, 0);
		gridPane.add(checkBoxAlkoholisch, 1, 0);
		gridPane.add(labelMl, 0, 1);
		gridPane.add(textFieldMl, 1, 1);
		gridPane.add(labelPreis, 0, 2);
		gridPane.add(sliderPreis, 1, 2);
		gridPane.add(buttonOk, 0, 3);
		gridPane.add(buttonAbbruch, 1, 3);
		setScene(new Scene(gridPane));
	}
	
	private void addHandlers()
	{
		buttonAbbruch.setOnAction( event -> close() );
		buttonOk.setOnAction( event -> ubernehmen() );
	}
	
	private void ubernehmen()
	{
		try
		{
			getrank.setAlkoholisch(checkBoxAlkoholisch.isSelected());
			getrank.setMl(Integer.parseInt(textFieldMl.getText()));
			getrank.setPreis(sliderPreis.getValue());
			close();
		}
		catch (NumberFormatException e)
		{
			Main.showAlert(AlertType.ERROR, "Ml nur ganze Zahlen erlaubt!");
		}
		catch (GetrankException e)
		{
			Main.showAlert(AlertType.ERROR, e.getMessage());
		}
	}
	
	public void updateAndShow(Getrank welches)
	{
		getrank = welches;
		checkBoxAlkoholisch.setSelected(welches.isAlkoholisch());
		textFieldMl.setText(""+welches.getMl());
		sliderPreis.setValue(welches.getPreis());
		showAndWait();
	}
}
