package application;

import java.util.ArrayList;

import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import model.Getrank;

public class GetrankeUbersicht extends TableView<Getrank>
{
	private TableColumn<Getrank, String> columnAlkoholisch;
	private TableColumn<Getrank, Integer> columnMl;
	private TableColumn<Getrank, Double> columnPreis;
	
	public GetrankeUbersicht()
	{
		initComponents();
		addComponents();
		addCellValueFactories();
	}

	private void initComponents()
	{
		columnAlkoholisch = new TableColumn<>("Alkoholisch");
			columnAlkoholisch.setPrefWidth(100);
		columnMl = new TableColumn<>("Ml");
			columnMl.setPrefWidth(100);
		columnPreis = new TableColumn<>("Preis");
			columnPreis.setPrefWidth(100);
	}

	private void addComponents()
	{
		getColumns().addAll(columnAlkoholisch, columnMl, columnPreis);
	}
	
	private void addCellValueFactories()
	{
		columnAlkoholisch.setCellValueFactory( new PropertyValueFactory<>("alkoholisch"));
		columnMl.setCellValueFactory( new PropertyValueFactory<>("ml"));
		columnPreis.setCellValueFactory( new PropertyValueFactory<>("preis"));
	}
	
	public void updateUbersicht(ArrayList<Getrank> getranke)
	{
		getItems().setAll(getranke);
	}
	
	public Getrank setSingleSelectedLine()
	{
		return getSelectionModel().getSelectedItem();
	}
}






















